<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, user-scalable=no, minimum-scale=1.0, maximum-scale=1.0"/>

    <title>NAP Plus-API</title>

    <?php include("link.html"); ?>
  </head>

  <body>
    
    <!-- Layout wrapper -->
    <div class="layout-wrapper layout-content-navbar">
      <div class="layout-container">

        <!-- Menu -->
        <?php include("menu.php"); ?>
        <!-- / Menu -->

        <!-- Layout container -->
        <div class="layout-page">

          <!-- nav -->
          <?php include("nav.php"); ?>
          <!-- nav -->

          <!-- Content wrapper -->
          <div class="content-wrapper">
            <!-- Content -->

            <div class="container-xxl flex-grow-1 container-p-y">
              <div class="row">
                <div class="col-lg-12 mb-4 order-0">
                  <div class="card">
                    <div class="d-flex align-items-end row">
                      <div class="col-sm-12">
                        <div class="card-body">
                          <h2>HIV/PCR Result - ดูผล LAB จาก NAPP</h2>
                            <div class="row">
                                <div class="col-md-3">
                                    <label for="start_date" class="form-label">จากวันที่</label>
                                    <input type="date" id="start_date" class="form-control">
                                </div>
                                <div class="col-md-3">
                                    <label for="end_date" class="form-label">ถึงวันที่</label>
                                    <input type="date" id="end_date" class="form-control">
                                </div>
                                <div class="col-md-3">
                                    <label for="lab_type" class="form-label">Lab Type</label>
                                    <select id="lab_type" class="form-select">
                                       <option value="101">ANTIHIV</option>
                                       <option value="102">PCR</option>
                                    </select>
                                </div>
                            <div class="col-md-3 d-flex align-items-end">
                                <button id="searchBtn" class="btn btn-primary w-100">ค้นหา</button>
                            </div>
                        </div>
                        <hr>
                        <table id="labTable" class="table" width="100%">
                            <thead>
                                <tr>
                                    <th>LAB_ITEM</th>
                                    <th>LAB_REQUEST_ID</th>
                                    <th>LAB_TYPE</th>
                                    <th>RESULT_DATE</th>
                                    <th>TEST_RESULT</th>
                                </tr>
                            </thead>
                            <tbody></tbody>
                        </table>
                          
                        </div>
                      </div>
                      
                    </div>
                  </div>
                </div>
                
              
            </div>
            <!-- / Content -->

            <!-- footer -->
            <?php include("footer.php"); ?>
            <!-- footer -->

            <div class="content-backdrop fade"></div>
          </div>
          <!-- Content wrapper -->
        </div>
        <!-- / Layout page -->
      </div>

      <!-- Overlay -->
      <div class="layout-overlay layout-menu-toggle"></div>
    </div>
    <!-- / Layout wrapper -->

    <div class="buy-now">
      <a
        href="#"
        target="_blank"
        class="btn btn-danger btn-buy-now"
        >ผู้พัฒนา</a
      >
    </div>

    <!-- Core JS -->
    <!-- build:js assets/vendor/js/core.js -->
    <!-- <script src="../assets/vendor/libs/jquery/jquery.js"></script> -->
    <script src="../assets/vendor/libs/popper/popper.js"></script>
    <script src="../assets/vendor/js/bootstrap.js"></script>
    <script src="../assets/vendor/libs/perfect-scrollbar/perfect-scrollbar.js"></script>

    <script src="../assets/vendor/js/menu.js"></script>
    <!-- endbuild -->

    <!-- Vendors JS -->
    <script src="../assets/vendor/libs/apex-charts/apexcharts.js"></script>

    <!-- Main JS -->
    <script src="../assets/js/main.js"></script>

    <!-- Page JS -->
    <script src="../assets/js/dashboards-analytics.js"></script>

    <!-- Place this tag in your head or just before your close body tag. -->
    <script async defer src="https://buttons.github.io/buttons.js"></script>

<script>
$(document).ready(function() {
    $('#searchBtn').click(function() {
        let startDate = $('#start_date').val();
        let endDate = $('#end_date').val();
        let labType = $('#lab_type').val();

        if(startDate && endDate && labType) {
            Swal.fire({
                title: 'กำลังค้นหา...',
                text: 'กรุณารอสักครู่ครับ',
                allowOutsideClick: false,
                didOpen: () => {
                    Swal.showLoading();
                }
            });

            $.ajax({
                url: 'fetch_antihiv_result.php', // URL ของ PHP ที่ดึงข้อมูลจาก API
                type: 'POST',
                dataType: 'json', // ให้ jQuery แปลง JSON เป็น object อัตโนมัติ
                data: {
                    start_date: startDate,
                    end_date: endDate,
                    lab_type: labType
                },
                success: function(data) {
                    console.log('Data received:', data);
                    
                    let tableData = [];
                    data.LAB_RESULT.forEach(function(item) {
                        tableData.push({
                            LAB_ITEM: item.LAB_ITEM,
                            LAB_REQUEST_ID: item.LAB_REQUEST_ID,
                            LAB_TYPE: item.LAB_TYPE,
                            RESULT_DATE: item.RESULT_DATE,
                            TEST_RESULT: item.TEST_RESULT.result2 // เข้าถึง result2 ภายใน TEST_RESULT
                        });
                    });

                    let table = $('#labTable').DataTable();
                    table.clear().draw();
                    table.rows.add(tableData).draw();
                    Swal.close();
                },
                error: function(jqXHR, textStatus, errorThrown) {
                    console.error('Error fetching data:', textStatus, errorThrown);
                }
            });

        } else {
            alert("Please fill all fields");
        }
    });

    $('#labTable').DataTable({
        columns: [
            { data: 'LAB_ITEM' },
            { data: 'LAB_REQUEST_ID' },
            { data: 'LAB_TYPE' },
            { data: 'RESULT_DATE' },
            { data: 'TEST_RESULT' } // คอลัมน์สำหรับแสดง result2
        ]
    });
});


</script>
  </body>
</html>
