<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, user-scalable=no, minimum-scale=1.0, maximum-scale=1.0"/>

    <title>NAP Plus-API</title>

    <?php include("link.html"); 
          
    ?>

    <style>
    /* กำหนดขนาดคอลัมน์ที่เหมาะสม */
    #labTable th, #labTable td {
        white-space: nowrap; /* ไม่ให้ข้อความตัดบรรทัด */
        text-align: center; /* จัดข้อความให้อยู่กลาง */
    }

    /* กำหนดความกว้างเฉพาะของคอลัมน์ */
    #labTable th:nth-child(1), #labTable td:nth-child(1) { width: 100px; } /* PATIENT_ID */
    #labTable th:nth-child(2), #labTable td:nth-child(2) { width: 150px; } /* LAB_REQUEST_ID */
    #labTable th:nth-child(3), #labTable td:nth-child(3) { width: 100px; } /* REQUEST_DATE */
    #labTable th:nth-child(4), #labTable td:nth-child(4) { width: 100px; } /* LAB_STATUS */
    #labTable th:nth-child(5), #labTable td:nth-child(5) { width: 100px; } /* HN */
    #labTable th:nth-child(6), #labTable td:nth-child(6) { width: 100px; } /* order_date */
    #labTable th:nth-child(7), #labTable td:nth-child(7) { width: 100px; } /* report_date */
    #labTable th:nth-child(8), #labTable td:nth-child(8) { width: 100px; } /* item_5 */
    #labTable th:nth-child(9), #labTable td:nth-child(9) { width: 100px; } /* item_3 */
    #labTable th:nth-child(10), #labTable td:nth-child(10) { width: 100px; } /* item_78 */
    #labTable th:nth-child(11), #labTable td:nth-child(11) { width: 100px; } /* item_102 */
    #labTable th:nth-child(12), #labTable td:nth-child(12) { width: 100px; } /* item_600 */
    #labTable th:nth-child(13), #labTable td:nth-child(13) { width: 100px; } /* item_103 */
    #labTable th:nth-child(14), #labTable td:nth-child(14) { width: 100px; } /* item_100 */
    #labTable th:nth-child(15), #labTable td:nth-child(15) { width: 150px; } /* Action */
</style>



  </head>

  <body>
    <!-- Layout wrapper -->
    <div class="layout-wrapper layout-content-navbar">
      <div class="layout-container">

        <!-- Menu -->
        <?php include("menu.php"); ?>
        <!-- / Menu -->

        <!-- Layout container -->
        <div class="layout-page">

          <!-- nav -->
          <?php include("nav.php"); ?>
          <!-- nav -->

          <!-- Content wrapper -->
          <div class="content-wrapper">
            <!-- Content -->

            <div class="container-xxl flex-grow-1 container-p-y">
              <div class="row">
                <div class="col-lg-12 mb-4 order-0">
                  <div class="card">
                    <div class="d-flex align-items-end row">
                      <div class="col-sm-12">
                        <div class="card-body">
                          <h2>Blood Chemistry Requests</h2>
                          <div class="row mb-4">
                              <div class="col-md-3">
                                  <label for="start_date" class="form-label">จากวันที่</label>
                                  <input type="date" id="start_date" class="form-control">
                              </div>
                              <div class="col-md-3">
                                  <label for="end_date" class="form-label">ถึงวันที่</label>
                                  <input type="date" id="end_date" class="form-control">
                              </div>
                              <div class="col-md-3 d-flex align-items-end">
                                  <button id="searchBtn" class="btn btn-primary w-100">ค้นหา</button>
                              </div>
                          </div>
                          <!-- hospital code api -->
                          <input type="text" name="hcode_txt" value="<?php echo $hcode; ?>" hidden>
                          <div id="lab-results-container">
                              <table id="labTable" class="table table-striped">
                                  <thead>
                                      <tr>
                                         <th>NAPP_No.</th>
                                        <th width="20%">LAB_REQUEST_ID</th>
                                        <th>REQUEST_DATE</th>
                                        <th width="5%">STATUS</th>
                                        <th width="5%">HN</th>
                                        <th>Order Date</th>
                                        <th>Report Date</th>
                                        <th>WBC</th>
                                        <th>Hb</th>
                                        <th>Cr.</th>
                                        <th>Chol</th>
                                        <th>FBS</th>
                                        <th>TG</th>
                                        <th>SGTP (ALT)</th>
                                        <th>Action</th>
                                      </tr>
                                  </thead>
                                  <tbody></tbody>
                              </table>
                          </div>
                          
                        </div>
                      </div>
                      
                    </div>
                  </div>
                </div>
                
              
            </div>
            <!-- / Content -->

            <!-- footer -->
            <?php include("footer.php"); ?>
            <!-- footer -->

            <div class="content-backdrop fade"></div>
          </div>
          <!-- Content wrapper -->
        </div>
        <!-- / Layout page -->
      </div>

      <!-- Overlay -->
      <div class="layout-overlay layout-menu-toggle"></div>
    </div>
    <!-- / Layout wrapper -->

    <div class="buy-now">
      <a
        href="#"
        target="_blank"
        class="btn btn-danger btn-buy-now"
        >ผู้พัฒนา</a
      >
    </div>

    <!-- Core JS -->
    <!-- build:js assets/vendor/js/core.js -->
    <!-- <script src="../assets/vendor/libs/jquery/jquery.js"></script> -->
    <script src="../assets/vendor/libs/popper/popper.js"></script>
    <script src="../assets/vendor/js/bootstrap.js"></script>
    <script src="../assets/vendor/libs/perfect-scrollbar/perfect-scrollbar.js"></script>

    <script src="../assets/vendor/js/menu.js"></script>
    <!-- endbuild -->

    <!-- Vendors JS -->
    <script src="../assets/vendor/libs/apex-charts/apexcharts.js"></script>

    <!-- Main JS -->
    <script src="../assets/js/main.js"></script>

    <!-- Page JS -->
    <script src="../assets/js/dashboards-analytics.js"></script>

    <!-- Place this tag in your head or just before your close body tag. -->
    <script async defer src="https://buttons.github.io/buttons.js"></script>
    <script src="js_bc_items.js"></script>

<script>
$(document).ready(function() {

    function formatDateToThai(dateString) {
    const months = ["ม.ค.", "ก.พ.", "มี.ค.", "เม.ย.", "พ.ค.", "มิ.ย.", "ก.ค.", "ส.ค.", "ก.ย.", "ต.ค.", "พ.ย.", "ธ.ค."];
    let dateParts = dateString.split("-");
    let year = parseInt(dateParts[0]) + 543; // แปลงปีเป็นพุทธศักราช
    let month = months[parseInt(dateParts[1]) - 1];
    let day = parseInt(dateParts[2]);
    return `${day} ${month} ${year.toString().slice(-2)}`;
    }

    function formatDateBuddhistToThai(dateString) {
        const months = ["ม.ค.", "ก.พ.", "มี.ค.", "เม.ย.", "พ.ค.", "มิ.ย.", "ก.ค.", "ส.ค.", "ก.ย.", "ต.ค.", "พ.ย.", "ธ.ค."];
        let year = dateString.slice(0, 4);
        let month = dateString.slice(4, 6);
        let day = dateString.slice(6, 8);

        let yearAD = parseInt(year) - 543; // แปลงจากปีพุทธศักราชเป็นคริสต์ศักราช
        let monthThai = months[parseInt(month) - 1];
        let yearShort = year.slice(-2); // ตัดเอาเฉพาะ 2 หลักสุดท้ายของปี พ.ศ.

        return `${parseInt(day)} ${monthThai} ${yearShort}`;
    }

    $('#searchBtn').click(function() {
        let startDate = $('#start_date').val();
        let endDate = $('#end_date').val();

        if (startDate && endDate) {
            Swal.fire({
                title: 'Loading...',
                text: 'Please wait while data is being loaded.',
                allowOutsideClick: false,
                didOpen: () => {
                    Swal.showLoading();
                }
            });

            let start_date_buddhist = new Date(startDate).toLocaleDateString('th-TH', { year: 'numeric', month: '2-digit', day: '2-digit' }).split('/').reverse().join('');
            let end_date_buddhist = new Date(endDate).toLocaleDateString('th-TH', { year: 'numeric', month: '2-digit', day: '2-digit' }).split('/').reverse().join('');

            $.ajax({
    url: 'fetch_bc_request.php',
    type: 'POST',
    dataType: 'json',
    data: {
        start_date: start_date_buddhist,
        end_date: end_date_buddhist
    },
    success: function(data) {
        console.log('Data received:', data); // ตรวจสอบข้อมูลที่ได้จาก API

        if (data.RESULT === "1" && Array.isArray(data.LAB_REQUEST) && data.LAB_REQUEST.length > 0) {
            let table = $('#labTable').DataTable();
            table.clear();

            data.LAB_REQUEST.forEach(function(result) {
                $.ajax({
                    url: 'fetch_bc_additional_data.php',
                    type: 'POST',
                    dataType: 'json',
                    data: {
                        patient_id: result.PATIENT_ID,
                        request_date: result.REQUEST_DATE
                    },
                    success: function(labData) {
                        console.log('Lab Data received:', labData); // ตรวจสอบข้อมูลจากฐานข้อมูล
                        // console.log('lab_items_code:', labResult.lab_items_code);

                        let rowData = {
                            PATIENT_ID: result.PATIENT_ID,
                            LAB_REQUEST_ID: result.LAB_REQUEST_ID,
                            REQUEST_DATE: formatDateBuddhistToThai(result.REQUEST_DATE),
                            LAB_STATUS: result.LAB_STATUS,
                            HN: 'N/A',
                            order_date: 'N/A',
                            report_date: 'N/A',
                            item_5: 'N/A',
                            item_3: 'N/A',
                            item_78: 'N/A',
                            item_102: 'N/A',
                            item_600: 'N/A',
                            item_103: 'N/A',
                            item_100: 'N/A',
                            action: 'N/A'
                        };

                        if (labData.length > 0) {
                            rowData.HN = labData[0].hn;
                            rowData.order_date = formatDateToThai(labData[0].order_date);
                            rowData.report_date = formatDateToThai(labData[0].report_date);

                            labData.forEach(function(labResult) {
                                let labCode = String(labResult.lab_items_code).trim(); // แปลงเป็น string และทำการ trim

                                // console.log('Processing lab_items_code:', labCode);

                                switch (labCode) {
                                    case wbc:
                                        rowData.item_5 = labResult.lab_order_result;
                                        break;
                                    case hb:
                                        rowData.item_3 = labResult.lab_order_result;
                                        break;
                                    case cr:
                                        rowData.item_78 = labResult.lab_order_result;
                                        break;
                                    case chol:
                                        rowData.item_102 = labResult.lab_order_result;
                                        break;
                                    case tg:
                                        rowData.item_103 = labResult.lab_order_result;
                                        break;
                                    case fbs:
                                        rowData.item_600 = labResult.lab_order_result;
                                        break;
                                    case sgpt_alt:
                                        rowData.item_100 = labResult.lab_order_result;
                                        break;
                                    default:
                                        // console.log('Unknown lab_items_code:', labCode);
                                }
                            });

                            // ในส่วนของโค้ดที่สร้างแถวข้อมูล (rowData) และปุ่ม "ส่งผล"
                            if (result.LAB_STATUS === "ตรวจ") {
                                rowData.action = `<button class="btn btn-success confirm-button" disabled>ส่งแล้ว</button>`;
                            } else {
                                rowData.action = `<button class="btn btn-warning confirm-button" data-hn="${labData[0].hn}" data-request-date="${labData[0].order_date}">ส่งผล</button>`;
                            }

                            // rowData.action = `<button class="btn btn-success confirm-button" data-hn="${labData[0].hn}" data-request-date="${labData[0].order_date}">ส่งผล</button>`;
                        }

                        console.log('Row Data:', rowData); // ตรวจสอบข้อมูลที่กำลังจะแสดงใน DataTable
                        table.row.add(rowData).draw();
                    },
                    error: function(jqXHR, textStatus, errorThrown) {
                        console.error('Error fetching lab data:', textStatus, errorThrown);
                    }
                });
            });
        } else {
            Swal.fire({
                icon: 'warning',
                title: 'No data found',
                text: 'No lab requests were found for the selected date range.',
            });
        }

        Swal.close();
    },
    error: function(jqXHR, textStatus, errorThrown) {
        Swal.fire({
            icon: 'error',
            title: 'Error',
            text: 'Failed to load data. Please try again later.',
        });
    }
});
        } else {
            Swal.fire({
                icon: 'warning',
                title: 'Missing Dates',
                text: 'Please select both start and end dates.',
            });
        }
    });

    $('#labTable').DataTable({
        scrollX: true,  // เปิดการเลื่อนในแนวนอน
    autoWidth: false, // ไม่ให้ปรับขนาดอัตโนมัติ เพื่อใช้ขนาดที่กำหนดใน CSS
        columns: [
            { data: 'PATIENT_ID' },
            { data: 'LAB_REQUEST_ID' },
            { data: 'REQUEST_DATE' },
            { data: 'LAB_STATUS' },
            { data: 'HN' },
            { data: 'order_date' },
            { data: 'report_date' },
            { data: 'item_5' },
            { data: 'item_3' },
            { data: 'item_78' },
            { data: 'item_102' },
            { data: 'item_600' },
            { data: 'item_103' },
            { data: 'item_100' },
            { data: 'action' }
        ]
    });

$('#labTable').on('click', '.confirm-button', function() {
    let hn = $(this).data('hn');
    let requestDate = $(this).data('request-date');

    // Convert requestDate to Buddhist year format
    let buddhistDate = requestDate.split('-');
    buddhistDate[0] = (parseInt(buddhistDate[0]) + 543).toString();
    let formattedBuddhistDate = buddhistDate.join('');

    // Assuming LAB_REQUEST_ID is in the second column (adjust as needed)
    let labRequestId = $(this).closest('tr').find('td').eq(1).text();

    let hcodeLab = $("hcode_txt").val(); // Hospital code
    let labType = "204"; // Lab type

    // Collect all test results into an object
    let testResults = {
        "WBC": $(this).closest('tr').find('td').eq(7).text(),
        "Hb": $(this).closest('tr').find('td').eq(8).text(),
        "Cr": $(this).closest('tr').find('td').eq(9).text(),
        "Chol": $(this).closest('tr').find('td').eq(10).text(),
        "FBS": $(this).closest('tr').find('td').eq(11).text(),
        "TG": $(this).closest('tr').find('td').eq(12).text(),
        "SGPT (ALT)": $(this).closest('tr').find('td').eq(13).text()
    };

    // Removing empty fields from the testResults object
    Object.keys(testResults).forEach(key => {
        if (testResults[key] === 'N/A' || testResults[key] === '') {
            delete testResults[key];
        }
    });

    let postData = {
        "HEADER": {
            "HCODE_LAB": hcodeLab,
            "LAB_TYPE": labType,
            "LAB_REQUEST_ID": labRequestId,
            "RESULT_DATE_FROM": formattedBuddhistDate,
            "RESULT_DATE_TO": formattedBuddhistDate,
            "LAB_STATUS": "1"
        },
        "LAB_RESULT": [
            {
                "LAB_TYPE": labType,
                "LAB_REQUEST_ID": labRequestId,
                "RESULT_DATE": formattedBuddhistDate,
                "HCODE_LAB": hcodeLab,
                "HCODE_LAB_OTHER": "",
                "IS_DETECTED": "1",
                "TEST_RESULT": testResults,
                "REMARK_NODETECTED": ""
            }
        ]
    };

    console.log("Post Data:", postData); // Debug: Check your data before sending
    let button = $(this); // Store a reference to the button for later

    $.ajax({
        url: 'submit_lab_result.php', // Your server-side script
        type: 'POST',
        dataType: 'json',
        data: {
            lab_request_id: labRequestId,
            report_date: formattedBuddhistDate,
            test_results: testResults
        },
        success: function(response) {
            if (response.RESULT === "1") {
                Swal.fire('Confirmed!', response.RESULT_MESSAGE, 'success');
                // $(this).prop('disabled', true); // Disable the button after confirmation
                button.prop('disabled', true); // Disable the button after confirmation
            } else {
                Swal.fire('Error!', 'There was an issue: ' + response.RESULT_MESSAGE, 'error');
            }
        },
        error: function(jqXHR, textStatus, errorThrown) {
            console.log('Response Text:', jqXHR.responseText);
            Swal.fire('Error!', 'Failed to send data to the API: ' + textStatus, 'error');
        }
    });
});





});
</script>
  </body>
</html>
