<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, user-scalable=no, minimum-scale=1.0, maximum-scale=1.0"/>

    <title>NAP Plus-API</title>

    <?php include("link.html"); ?>

    <style>
    /* กำหนดขนาดคอลัมน์ที่เหมาะสม */
    #labTable th, #labTable td {
        white-space: nowrap; /* ไม่ให้ข้อความตัดบรรทัด */
        text-align: center; /* จัดข้อความให้อยู่กลาง */
    }

    /* กำหนดความกว้างเฉพาะของคอลัมน์ */
    #labTable th:nth-child(1), #labTable td:nth-child(1) { width: 100px; } /* PATIENT_ID */
    #labTable th:nth-child(2), #labTable td:nth-child(2) { width: 150px; } /* LAB_REQUEST_ID */
    #labTable th:nth-child(3), #labTable td:nth-child(3) { width: 100px; } /* REQUEST_DATE */
    #labTable th:nth-child(4), #labTable td:nth-child(4) { width: 100px; } /* LAB_STATUS */
    #labTable th:nth-child(5), #labTable td:nth-child(5) { width: 100px; } /* HN */
    #labTable th:nth-child(6), #labTable td:nth-child(6) { width: 100px; } /* order_date */
    #labTable th:nth-child(7), #labTable td:nth-child(7) { width: 100px; } /* report_date */
    #labTable th:nth-child(8), #labTable td:nth-child(8) { width: 100px; } /* item_5 */
    #labTable th:nth-child(9), #labTable td:nth-child(9) { width: 100px; } /* item_3 */
    #labTable th:nth-child(10), #labTable td:nth-child(10) { width: 100px; } /* item_78 */
    #labTable th:nth-child(11), #labTable td:nth-child(11) { width: 100px; } /* item_102 */
    #labTable th:nth-child(12), #labTable td:nth-child(12) { width: 100px; } /* item_600 */
    #labTable th:nth-child(13), #labTable td:nth-child(13) { width: 100px; } /* item_103 */
    #labTable th:nth-child(14), #labTable td:nth-child(14) { width: 100px; } /* item_100 */
    #labTable th:nth-child(15), #labTable td:nth-child(15) { width: 150px; } /* Action */
</style>



  </head>

  <body>
    <!-- Layout wrapper -->
    <div class="layout-wrapper layout-content-navbar">
      <div class="layout-container">

        <!-- Menu -->
        <?php include("menu.php"); ?>
        <!-- / Menu -->

        <!-- Layout container -->
        <div class="layout-page">

          <!-- nav -->
          <?php include("nav.php"); ?>
          <!-- nav -->

          <!-- Content wrapper -->
          <div class="content-wrapper">
            <!-- Content -->

            <div class="container-xxl flex-grow-1 container-p-y">
              <div class="row">
                <div class="col-lg-12 mb-4 order-0">
                  <div class="card">
                    <div class="d-flex align-items-end row">
                      <div class="col-sm-12">
                        <div class="card-body">
                          <h2>Blood Chemistry Result - ดูผล Lab จาก NAPP</h2>
                          <div class="row mb-4">
                              <div class="col-md-3">
                                  <label for="start_date" class="form-label">จากวันที่</label>
                                  <input type="date" id="start_date" class="form-control">
                              </div>
                              <div class="col-md-3">
                                  <label for="end_date" class="form-label">ถึงวันที่</label>
                                  <input type="date" id="end_date" class="form-control">
                              </div>
                              <div class="col-md-3 d-flex align-items-end">
                                  <button id="searchBtn" class="btn btn-primary w-100">ค้นหา</button>
                              </div>
                          </div>
                          <div id="lab-results-container">
                              <table id="labTable" class="table table-striped">
                                  <thead>
                                      <tr>
                                        <th>LAB_REQUEST_ID</th>
                                        <th>RESULT_DATE</th>
                                        <th>WBC</th>
                                        <th>Hb</th>
                                        <th>Cr.</th>
                                        <th>Chol</th>
                                        <th>FBS</th>
                                        <th>TG</th>
                                        <th>SGTP (ALT)</th>
                                      </tr>
                                  </thead>
                                  <tbody></tbody>
                              </table>
                          </div>
                          
                        </div>
                      </div>
                      
                    </div>
                  </div>
                </div>
                
              
            </div>
            <!-- / Content -->

            <!-- footer -->
            <?php include("footer.php"); ?>
            <!-- footer -->

            <div class="content-backdrop fade"></div>
          </div>
          <!-- Content wrapper -->
        </div>
        <!-- / Layout page -->
      </div>

      <!-- Overlay -->
      <div class="layout-overlay layout-menu-toggle"></div>
    </div>
    <!-- / Layout wrapper -->

    <div class="buy-now">
      <a
        href="#"
        target="_blank"
        class="btn btn-danger btn-buy-now"
        >ผู้พัฒนา</a
      >
    </div>

    <!-- Core JS -->
    <!-- build:js assets/vendor/js/core.js -->
    <!-- <script src="../assets/vendor/libs/jquery/jquery.js"></script> -->
    <script src="../assets/vendor/libs/popper/popper.js"></script>
    <script src="../assets/vendor/js/bootstrap.js"></script>
    <script src="../assets/vendor/libs/perfect-scrollbar/perfect-scrollbar.js"></script>

    <script src="../assets/vendor/js/menu.js"></script>
    <!-- endbuild -->

    <!-- Vendors JS -->
    <script src="../assets/vendor/libs/apex-charts/apexcharts.js"></script>

    <!-- Main JS -->
    <script src="../assets/js/main.js"></script>

    <!-- Page JS -->
    <script src="../assets/js/dashboards-analytics.js"></script>

    <!-- Place this tag in your head or just before your close body tag. -->
    <script async defer src="https://buttons.github.io/buttons.js"></script>

<script>
$(document).ready(function() {
  $('#searchBtn').click(function() {
    let startDate = $('#start_date').val();
    let endDate = $('#end_date').val();

    if (startDate && endDate) {
        $.ajax({
            url: 'fetch_bc_result.php',
            type: 'POST',
            dataType: 'json',
            data: {
                start_date: startDate,
                end_date: endDate
            },
            success: function(data) {
                console.log('Data received:', data);

                if (data.RESULT === "1" && Array.isArray(data.LAB_RESULT) && data.LAB_RESULT.length > 0) {
                    $('#labTable').DataTable({
                        destroy: true, // ล้าง DataTable เดิม
                        columns: [
                            { title: 'LAB_REQUEST_ID', data: 'LAB_REQUEST_ID' },
                            { title: 'RESULT_DATE', data: 'RESULT_DATE' },
                            { title: 'WBC', data: 'WBC' },
                            { title: 'Hb', data: 'Hb' },
                            { title: 'Cr.', data: 'Cr' },
                            { title: 'Chol', data: 'Chol' },
                            { title: 'FBS', data: 'FBS' },
                            { title: 'TG', data: 'TG' },
                            { title: 'SGTP (ALT)', data: 'SGTP_ALT' }
                        ],
                        data: [],
                        scrollX: true,
                        autoWidth: false
                    });

                    let table = $('#labTable').DataTable();
                    table.clear();

                    let groupedData = {};

                    data.LAB_RESULT.forEach(function(labItem) {
                        if (!groupedData[labItem.LAB_REQUEST_ID]) {
                            groupedData[labItem.LAB_REQUEST_ID] = {
                                LAB_REQUEST_ID: labItem.LAB_REQUEST_ID,
                                RESULT_DATE: labItem.RESULT_DATE ? formatDateBuddhistToThai(labItem.RESULT_DATE) : 'N/A',
                                WBC: 'N/A',
                                Hb: 'N/A',
                                Cr: 'N/A',
                                Chol: 'N/A',
                                FBS: 'N/A',
                                TG: 'N/A',
                                SGTP_ALT: 'N/A'
                            };
                        }
                        switch (labItem.LAB_ITEM) {
                            case 'WBC':
                                groupedData[labItem.LAB_REQUEST_ID].WBC = labItem.TEST_RESULT.result1 || 'N/A';
                                break;
                            case 'Hb':
                                groupedData[labItem.LAB_REQUEST_ID].Hb = labItem.TEST_RESULT.result1 || 'N/A';
                                break;
                            case 'Cr.':
                                groupedData[labItem.LAB_REQUEST_ID].Cr = labItem.TEST_RESULT.result1 || 'N/A';
                                break;
                            case 'Chol.':
                                groupedData[labItem.LAB_REQUEST_ID].Chol = labItem.TEST_RESULT.result1 || 'N/A';
                                break;
                            case 'FBS':
                                groupedData[labItem.LAB_REQUEST_ID].FBS = labItem.TEST_RESULT.result1 || 'N/A';
                                break;
                            case 'TG':
                                groupedData[labItem.LAB_REQUEST_ID].TG = labItem.TEST_RESULT.result1 || 'N/A';
                                break;
                            case 'sGPT(ALT)':
                                groupedData[labItem.LAB_REQUEST_ID].SGTP_ALT = labItem.TEST_RESULT.result1 || 'N/A';
                                break;
                            default:
                                break;
                        }
                    });

                    Object.values(groupedData).forEach(function(rowData) {
                        table.row.add(rowData).draw();
                    });

                } else {
                    Swal.fire({
                        icon: 'warning',
                        title: 'No data found',
                        text: 'No lab results found for the selected date range.',
                    });
                }
            },
            error: function(jqXHR, textStatus, errorThrown) {
                Swal.fire({
                    icon: 'error',
                    title: 'Error',
                    text: 'Failed to load data. Please try again later.',
                });
                console.log('Error fetching lab results:', textStatus, errorThrown);
            }
        });
    } else {
        Swal.fire({
            icon: 'warning',
            title: 'Missing Dates',
            text: 'Please select both start and end dates.',
        });
    }
});


    $('#labTable').DataTable({
    columns: [
        { data: 'LAB_REQUEST_ID', title: 'Lab Request ID' },
        { data: 'RESULT_DATE', title: 'Result Date' },
        { data: 'LAB_ITEM', title: 'Lab Item' },
        { data: 'TEST_RESULT', title: 'Test Result' }
    ]
});


    function formatDateBuddhistToThai(dateString) {
        const months = ["ม.ค.", "ก.พ.", "มี.ค.", "เม.ย.", "พ.ค.", "มิ.ย.", "ก.ค.", "ส.ค.", "ก.ย.", "ต.ค.", "พ.ย.", "ธ.ค."];
        let year = dateString.slice(0, 4);
        let month = dateString.slice(4, 6);
        let day = dateString.slice(6, 8);

        let yearAD = parseInt(year) - 543; // แปลงจากปีพุทธศักราชเป็นคริสต์ศักราช
        let monthThai = months[parseInt(month) - 1];
        let yearShort = year.slice(-2); // ตัดเอาเฉพาะ 2 หลักสุดท้ายของปี พ.ศ.

        return `${parseInt(day)} ${monthThai} ${yearShort}`;
    }

    $('#labTable').DataTable();
});
</script>
  </body>
</html>


