<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, user-scalable=no, minimum-scale=1.0, maximum-scale=1.0"/>

    <title>NAP Plus-API</title>

    <?php include("link.html"); ?>
  </head>

  <body>
    <!-- Layout wrapper -->
    <div class="layout-wrapper layout-content-navbar">
      <div class="layout-container">

        <!-- Menu -->
        <?php include("menu.php"); ?>
        <!-- / Menu -->

        <!-- Layout container -->
        <div class="layout-page">

          <!-- nav -->
          <?php include("nav.php"); ?>
          <!-- nav -->

          <!-- Content wrapper -->
          <div class="content-wrapper">
            <!-- Content -->

            <div class="container-xxl flex-grow-1 container-p-y">
              <div class="row">
                <div class="col-lg-12 mb-4 order-0">
                  <div class="card">
                    <div class="d-flex align-items-end row">
                      <div class="col-sm-12">
                        <div class="card-body">
                          <h2>HIV/PCR Requests</h2>
                            <div class="row">
                                <div class="col-md-3">
                                    <label for="start_date" class="form-label">จากวันที่</label>
                                    <input type="date" id="start_date" class="form-control">
                                </div>
                                <div class="col-md-3">
                                    <label for="end_date" class="form-label">ถึงวันที่</label>
                                    <input type="date" id="end_date" class="form-control">
                                </div>
                                <div class="col-md-3">
                                    <label for="lab_type" class="form-label">Lab Type</label>
                                    <select id="lab_type" class="form-select">
                                        <option value="101">ANTIHIV</option>          
                                    </select>
                                </div>
                            <div class="col-md-3 d-flex align-items-end">
                                <button id="searchBtn" class="btn btn-primary w-100">ค้นหา</button>
                            </div>
                        </div>
                        <hr>
                        <table id="orderTable" class="table" width="100%">
                            <thead>
                                <tr>
                                    <th>LAB_TYPE</th>
                                    <th>HN</th>
                                    <th>PATIENT_ID</th>
                                    <th>LAB_REQUEST_ID</th>
                                    <th>REQUEST_DATE</th>
                                    <th>LAB_STATUS</th>
                                    <!-- <th>order_date</th> -->
                                    <th>report_date</th>
                                    <th>lab_result</th>
                                    <!-- <th>PATIENT_RIGHT</th> -->
                                    <!-- <th>HCODE_LAB</th> -->
                                    
                                    <th>ส่งผล</th>
                                </tr>
                            </thead>
                            <tbody></tbody>
                        </table>
                          
                        </div>
                      </div>
                      
                    </div>
                  </div>
                </div>
                
              
            </div>
            <!-- / Content -->

            <!-- footer -->
            <?php include("footer.php"); ?>
            <!-- footer -->

            <div class="content-backdrop fade"></div>
          </div>
          <!-- Content wrapper -->
        </div>
        <!-- / Layout page -->
      </div>

      <!-- Overlay -->
      <div class="layout-overlay layout-menu-toggle"></div>
    </div>
    <!-- / Layout wrapper -->

    <div class="buy-now">
      <a
        href="#"
        target="_blank"
        class="btn btn-danger btn-buy-now"
        >ผู้พัฒนา</a
      >
    </div>

    <!-- Core JS -->
    <!-- build:js assets/vendor/js/core.js -->
    <!-- <script src="../assets/vendor/libs/jquery/jquery.js"></script> -->
    <script src="../assets/vendor/libs/popper/popper.js"></script>
    <script src="../assets/vendor/js/bootstrap.js"></script>
    <script src="../assets/vendor/libs/perfect-scrollbar/perfect-scrollbar.js"></script>

    <script src="../assets/vendor/js/menu.js"></script>
    <!-- endbuild -->

    <!-- Vendors JS -->
    <script src="../assets/vendor/libs/apex-charts/apexcharts.js"></script>

    <!-- Main JS -->
    <script src="../assets/js/main.js"></script>

    <!-- Page JS -->
    <script src="../assets/js/dashboards-analytics.js"></script>

    <!-- Place this tag in your head or just before your close body tag. -->
    <script async defer src="https://buttons.github.io/buttons.js"></script>

<script>
$(document).ready(function() {

    // ฟังก์ชันแปลง PATIENT_ID
function maskPatientId(patientId) {
    return patientId.slice(0, 8) + 'xxxxx';
}

    $('#searchBtn').click(function() {
        let startDate = $('#start_date').val();
        let endDate = $('#end_date').val();
        let labType = $('#lab_type').val();

        if(startDate && endDate && labType) {
            Swal.fire({
                title: 'กำลังค้นหา...',
                text: 'กรุณารอสักครู่ครับ',
                allowOutsideClick: false,
                didOpen: () => {
                    Swal.showLoading();
                }
            });

            $.ajax({
                url: 'fetch_order_data.php',
                type: 'POST',
                dataType: 'json',
                data: {
                    start_date: startDate,
                    end_date: endDate,
                    lab_type: labType
                },
                success: function(data) {
                    console.log('Data received:', data);
                    
                    if (data && Array.isArray(data)) {
                        let table = $('#orderTable').DataTable();
                        table.clear();

                        data.forEach(function(item) {

                            // ตรวจสอบค่า LAB_STATUS ถ้าเป็น "ตรวจ" ให้ปิดการใช้งานปุ่ม
                            let actionButton = '';
                            if (item.LAB_STATUS !== 'ตรวจ') {
                                actionButton = `<button class="btn btn-success confirm-button" 
                                                data-request-id="${item.LAB_REQUEST_ID}" 
                                                data-hcode-lab="${item.HCODE_LAB}" 
                                                data-lab-type="${item.LAB_TYPE}" 
                                                data-request-date="${item.REQUEST_DATE}"  
                                                data-lab-order-result="${item.lab_order_result}">
                                                ยืนยันส่งผล</button>`;
                            } else {
                                actionButton = `<button class="btn btn-secondary" disabled>ตรวจแล้ว</button>`;
                            }
                            
                            table.row.add({
                                LAB_TYPE: item.LAB_TYPE,
                                hn: item.hn,
                                PATIENT_ID: maskPatientId(item.PATIENT_ID),
                                 LAB_REQUEST_ID: item.LAB_REQUEST_ID,
                                 REQUEST_DATE: item.REQUEST_DATE,
                                 LAB_STATUS: item.LAB_STATUS,
                                // order_date: item.order_date,
                                report_date: item.report_date,
                                lab_order_result: item.lab_order_result,
                                // PATIENT_RIGHT: item.PATIENT_RIGHT,
                                // HCODE_LAB: item.HCODE_LAB,
                                
                                ACTIONS: actionButton
                            }).draw(false);
                        });

                        Swal.close();
                    } else {
                        console.error('LAB_REQUEST data is not an array:', data);
                        Swal.fire({
                            icon: 'error',
                            title: 'Error',
                            text: 'No valid data received. Please check your API response.',
                        });
                    }
                },
                error: function(jqXHR, textStatus, errorThrown) {
                    console.error('Error fetching data:', textStatus, errorThrown);

                    Swal.fire({
                        icon: 'error',
                        title: 'Error',
                        text: 'เกิดข้อผิดพลาดในการดึงข้อมูล.',
                    });
                }
            });
        } else {
            Swal.fire({
                icon: 'warning',
                title: 'พบข้อผิดพลาด',
                text: 'กรุณากรอกข้อมูลให้ถูกต้อง.',
            });
        }
    });

    $('#orderTable').DataTable({
        columns: [
            { data: 'LAB_TYPE' },
            { data: 'hn' },
            { data: 'PATIENT_ID' },
            { data: 'LAB_REQUEST_ID' },
            { data: 'REQUEST_DATE' },
             { data: 'LAB_STATUS' },
            // { data: 'order_date' },
            { data: 'report_date' },
            { data: 'lab_order_result' },
            
            // { data: 'PATIENT_RIGHT' },
            // { data: 'HCODE_LAB' },
           
            { data: 'ACTIONS' }
        ]
    });

    $('#orderTable').on('click', '.confirm-button', function() {
        let labRequestId = $(this).data('request-id');
        let hcodeLab = $(this).data('hcode-lab');
        let labType = $(this).data('lab-type');
        let requestDate = $(this).data('request-date');
        let labOrderResult = $(this).data('lab-order-result');

        Swal.fire({
            title: 'ยืนยันส่งผล เข้าระบบ Nap plus ?',
            text: `ยืนยันส่งผล: ${labRequestId}`,
            icon: 'warning',
            showCancelButton: true,
            confirmButtonColor: '#3085d6',
            cancelButtonColor: '#d33',
            confirmButtonText: 'ยืนยัน, ข้อมูลถูกต้อง!'
        }).then((result) => {
            if (result.isConfirmed) {
                $.ajax({
                    url: 'send_lab_result.php',
                    type: 'POST',
                    dataType: 'json',
                    data: {
                        HCODE_LAB: hcodeLab,
                        LAB_TYPE: labType,
                        LAB_REQUEST_ID: labRequestId,
                        REQUEST_DATE: requestDate,
                        lab_order_result: labOrderResult
                    },
                    success: function(response) {
                        console.log(response);

                        if (response.RESULT === '1') {
                            Swal.fire(
                                'Success!',
                                response.RESULT_MESSAGE,
                                'success'
                            ).then(() => {
                                // ปิดการใช้งานปุ่มหลังจากการยืนยันสำเร็จ
                                $(`[data-request-id="${labRequestId}"]`).prop('disabled', true);
                            });
                        } else {
                            Swal.fire(
                                'Error!',
                                'There was an issue: ' + response.RESULT_MESSAGE,
                                'error'
                            );
                        }
                    },
                    error: function(jqXHR, textStatus, errorThrown) {
                        Swal.fire(
                            'Error!',
                            'Failed to send data to the API: ' + textStatus,
                            'error'
                        );
                    }
                });
            }
        });
    });
});
</script>
  </body>
</html>